package org.tbasket


import org.apache.logging.log4j.LogManager
import zio._

import java.lang
import scala.io.StdIn
import scala.util.control.NonFatal

object Main {
    final val LOG = LogManager.getLogger("Core")

    def main(args: Array[String]): Unit = {
        LOG.info("Starting server")
        val endpoint = EndpointSetup.setupEndpoint()
        val runtime = Runtime.default
        Unsafe.unsafe { implicit u =>
            runtime.unsafe.run(endpoint.run).catchSome {
                case NonFatal(e) =>
                    e.printStackTrace()
                    throw e
            }
        }
        LOG.info("Server successfully started")
        println("enter to exit")
        StdIn.readLine()
    }

    //add a shutdown hook to log when the server is about to get killed
    lang.Runtime.getRuntime.addShutdownHook(new Thread(() => LOG.info("Server shutdowns")))

}
